<?php

namespace NoccyLabs\React\Http2\Connection;

use Evenement\EventEmitterInterface;
use Evenement\EventEmitterTrait;
use NoccyLabs\React\Http2\Frame\DataFrame;
use NoccyLabs\React\Http2\Frame\Frame;
use NoccyLabs\React\Http2\Frame\HeadersFrame;
use NoccyLabs\React\Http2\Frame\SettingsFrame;
use NoccyLabs\React\Http2\Stream\Http2Stream;
use Psr\Http\Message\ServerRequestInterface;
use React\Stream\DuplexStreamInterface;

/**
 * HTTP/2 Connecton Classs
 * 
 * 
 */
class Http2Connection implements EventEmitterInterface
{
    use EventEmitterTrait;

    /** @var string Emitted when a new stream is opened */
    const EVENT_OPEN = 'open';

    /** @var string Emitted when a the connection (and effectively all its streams) are closed */
    const EVENT_CLOSE = 'close';

    /** @var array<int,Http2Stream> The active streams, even for s2c, odd for c2s */
    private array $streams = [];

    /** @var int The last used stream identifier */
    private int $lastStream = 0;

    /** @var int Max number of streams that can be opened; assigned from settings frame */
    private int $maxStream = 0;

    /** @var DuplexStreamInterface The connection to the client */
    private DuplexStreamInterface $connection;

    private string $buffer = '';

    public function __construct(DuplexStreamInterface $connection, ServerRequestInterface $request, ?SettingsFrame $http2settings)
    {
        $this->connection = $connection;

        $connection->on('data', function ($data) {
            $this->buffer .= $data;
            $frame = Frame::parseFrame($this->buffer);
            $this->handleHttp2Frame($frame);
        });
       
    }

    private function handleHttp2Frame(Frame $frame)
    {
        switch ($frame->getFrameType()) {
            case Frame::FRAME_HEADERS:
                $this->handleHttp2HeadersFrame($frame);
                break;
            case Frame::FRAME_DATA:
                $this->handleHttp2DataFrame($frame);
                break;
            case Frame::FRAME_PING:
                $this->handleHttp2PingFrame($frame);
                break;
        }
    }

    private function handleHttp2HeadersFrame(HeadersFrame $frame)
    {
        $method = $frame->headers->getHeaderLine(':method');
        $scheme = $frame->headers->getHeaderLine(':scheme');
        $path = $frame->headers->getHeaderLine(':path');
    }

    private function handleHttp2DataFrame(DataFrame $frame)
    {

    }

    private function handleHttp2PingFrame(DataFrame $frame)
    {

    }

    

    /**
     * When a new stream is opened, clean up older streams that are idle or closed.
     * 
     * @return void
     */
    private function doStreamHouseKeeping(): void
    {

    }
}